<?php

if(!defined('PLX_ROOT'))
	exit;

define('L_ENABLED', $plxPlugin->getLang('L_ENABLED'));
define('L_DISABLED', $plxPlugin->getLang('L_DISABLED'));
define('PLUG_NAME', get_class($plxPlugin));

if(!empty($_POST)) {
	foreach($_POST as $key => $value) {
		if (strpos($key, FAMILY_PREFIX) === 0) {
			$plxPlugin->setParam($key, $value, 'numeric');
		}
	}
	$plxPlugin->saveParams();
	header('Location: parametres_plugin.php?p=' . PLUG_NAME);
	exit;
}

$aFamilies = $plxPlugin->getLoadedFamilies();
$aChoices = array(false => L_DISABLED, true => L_ENABLED);
?>

<h2><?php echo $plxPlugin->getInfo('title') ?></h2>

<form action="parametres_plugin.php?p=<?php echo PLUG_NAME ?>" method="post">
	<fieldset class="withlabel">
		<legend><?php $plxPlugin->lang('L_LEGEND') ?> :</legend>
<?php
	foreach ($aFamilies as $family => $enabled):
?>
		<p class="field"><label for="id_<?php echo FAMILY_PREFIX . $family ?>"><?php echo $family ?>&nbsp;:</label></p>
<?php
		plxUtils::printSelect(FAMILY_PREFIX . $family, $aChoices, $enabled);
	endforeach;
?>
		<p><input type="submit" name="submit" value="<?php $plxPlugin->lang('L_SAVE') ?>" /></p>
	</fieldset>
</form>

<?php
/*
 * Copyright (c) 2012, Humpf
 *
 * This file is part of plxTextReplace.
 * plxTextReplace is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * plxTextReplace is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with plxTextReplace.  If not, see <http://www.gnu.org/licenses/>.
 */
?>