<?php if(!defined('PLX_ROOT')) exit; ?>

<h2>Aide de plxTextReplace</h2>

<h3>Utilisation</h3>

<p class="breadcrumbs">Ce plugin s'adresse aux <strong>r&eacute;dacteurs</strong> qui ne connaissent pas le HTML 
ou le javascript mais aussi aux <strong>webmestres</strong> qui souhaitent modifier à la vol&eacute;e 
le contenu des pages publiques.</p>

<p class="breadcrumbs"><i>plxTextReplace</i> d&eacute;finit certaines balises  <a href="fr.wikipedia.org/wiki/BBCode">BBCode</a>
(par exemple : [b]...[/b]), et certaines balises obsol&egrave;tes du HTML3 et HTML4 (par exemple &lt;u&gt;...&lt;/u&gt;) 
afin de les transformer en HTML5.</p>

<p class="breadcrumbs">De plus, <i>plxTextReplace</i> définit une balise <kbd>&lt;audioplayer&gt;</kbd> qui n'est 
utile qu'avec le plugin <a href="http://websvn.pluxml.org/listing.php?repname=PluXml&path=%2Fplugins%2Faudio_player%2F&rev=1049&peg=1049">audio_player</a> activé.<br/>
Son format est : <kbd>&lt;audioplayer id="mettre_un_numero_unique" soundFile="mettre_chemin_mp3" titles="mettre_titre" artists="mettre_auteur"&gt;</kbd><br/>
Exemple : <kbd>&lt;audioplayer id="5" soundFile="data/documents/fic.mp3" titles="Super titre" artists="Super artiste"&gt;</kbd>
</p>

<h3>Configuration</h3>

<p class="breadcrumbs">Les balises configurées sont regroupées par "familles".<br/>
Par défaut, toutes les familles sont activées mais vous pouvez modifier individuellement leur activation avec la zone 
de sélection Actif/Inactif de la page de configuration du plugin.</p>

<h3>Configuration avancée</h3>

<p class="breadcrumbs">Les familles de balises de <i>plxTextReplace</i> sont définies dans le fichier <kbd>tags-default.xml</kbd>. <br/>
Vous pouvez créer le fichier <kbd>tags-custom.xml</kbd> pour y définir vos propres familles et balises. <br/>
<i>plxTextReplace</i> utilise les <a href="http://www.php.net/manual/fr/pcre.pattern.php">expressions régulières</a> 
du PHP pour rechercher et remplacer des patterns de caractères (les balises) dans toute page publique affichée 
juste avant qu'elle soit retournée au navigateur.</p>

<p class="breadcrumbs">Dans ces fichiers XML, l'élément <kbd>&lt;tag&gt;</kbd> déclare un pattern et le texte de remplacement.<p>

<pre>
  &lt;tag name="nom_balise" pattern="expression_regulière" replace="texte_remplacement" [attributes="..."]/&gt;

  &lt;tag name="nom_balise" pattern="expression_regulière" [attributes="..."]&gt;
    &lt;replace&gt;texte_remplacement&lt;/replace&gt;
  &lt;/tag&gt;
</pre>

<p class="breadcrumbs">Le seconde forme de <kbd>&lt;tag&gt;</kbd> est fonctionnellement identique à la première, 
mais elle permet de s'affranchir de l'échappement des caractères ' et " (voir l'exemple <kbd>&lt;audioplayer&gt;</kbd>).<br/>
Si, par erreur, deux textes de remplacement sont définis : un par l'attribut <kbd>replace="..."</kbd> et un 
autre par l'élément <kbd>&lt;replace&gt;</kbd>, le second est conservé.<p>

<p class="breadcrumbs">Après le rendu de la page par PluXml, les patterns sont recherchés dans l'ordre de leur déclaration, toutes familles confondues.<br/>
Néanmoins, les <kbd>&lt;tag&gt;</kbd> munis de <kbd>attributes="..."</kbd> seront exécutés en dernier.</p>

<p class="breadcrumbs">En cas de doublon du <kbd>nom_balise</kbd> (toutes familles confondues), la dernière définition est conservée. 
Ceci permet de remplacer les balises prédéfinies dans votre fichier <kbd>tags-custom.xml</kbd>.</p>

<p class="breadcrumbs">Vous pouvez étendre les familles de balises existantes dans votre fichier <kbd>tags-custom.xml</kbd>, 
en définissant une famille du m&ecirc;me nom.</p>

<p class="breadcrumbs">La documentation du format des <a href="http://www.php.net/manual/fr/pcre.pattern.php">expressions régulières</a>
et des <a href="http://fr.php.net/manual/fr/function.preg-replace.php">textes de remplacement</a> n'a pas sa place ici, mais à toute
fin utile, l'option "e" permet d'exécuter (évaluer) le texte de remplacement (voir l'exemple <kbd>MAJ-min</kbd>).<p>

<p class="breadcrumbs">Quand il est positionné, <kbd>attributes="html"</kbd> indique que la balise contient des attributs nommés au format HTML.<br/>
Ces attributs sont inclus dans le premier sous-masque du pattern (c.-à-d. définis par le premier groupe de parenthèses) 
(voir l'exemple <kbd>&lt;font&gt;</kbd> et <kbd>&lt;audioplayer&gt;</kbd>).<br/>
Par exemple : <kbd>&lt;balise src="smile.jpg" text="sourire"/&gt;</kbd> contient un attribut nommé <kbd>src</kbd> dont la 
valeur est <kbd>smile.jpg</kbd> et un attribut nommé <kbd>text</kbd> dont la valeur est <kbd>sourire</kbd>.<br/>
La valeur de ces attributs peut être placée dans le texte de remplacement avec la syntaxe <kbd>%{...}</kbd> 
(exemple : <kbd>%{text}</kbd> sera remplacé par <kbd>sourire</kbd>).<p>

<p class="breadcrumbs">Quand il est positionné, <kbd>attributes="bbcode"</kbd> indique que la balise contient des attributs nommés au format BBCode.<br/>
Par exemple : <kbd>[balise|src=smile.jpg|text=sourire]</kbd> contient un attribut nommé <kbd>src</kbd> dont la valeur est 
<kbd>smile.jpg</kbd> et un attribut nommé <kbd>text</kbd> dont la valeur est <kbd>sourire</kbd>.<br/>
La valeur de ces attributs peut être placée dans le texte de remplacement avec la syntaxe <kbd>%{...}</kbd> 
(exemple : <kbd>%{text}</kbd> sera remplacé par <kbd>sourire</kbd>).<p>

<p class="breadcrumbs">Actuellement, seules les valeurs <kbd>html</kbd> et <kbd>bbcode</kbd> sont définies pour <kbd>attributes</kbd>.
Cependant, il est possible d'y mettre une expression régulière de votre choix. <br/>
<i>plxTextReplace</i> a besoin que cette dernière contienne les sous-maques nommés <kbd>key</kbd> et <kbd>value</kbd>, c'est-&agrave;-dire : 
<kbd>(?P&lt;key&gt;<i>masque</i>)</kbd> et <kbd>(?P&lt;value&gt;<i>masque</i>)</kbd>, afin d'identifier le nom de l'attribut et sa valeur.</p>

<h3>Perspectives</h3>

<p class="breadcrumbs">Les patterns définis dans <i>plxTextReplace</i> ne se limitent pas aux balises. Il est possible de modifier 
tout fragment de HTML généré par PluXml : réécrire des URL, ajouter des feuilles de style ou du javascript, etc.<br/>
Bref, un pattern peut être vu comme un mini-plugin sans une ligne de PHP.</p>

<?php
/*
 * Copyright (c) 2012, Humpf
 *
 * This file is part of plxTextReplace.
 * plxTextReplace is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * plxTextReplace is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with plxTextReplace.  If not, see <http://www.gnu.org/licenses/>.
 */
?>
